package wheelpickerwrapper;

import main.java.com.aigestudio.wheelpicker.WheelPicker;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;
import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;
import java.util.ArrayList;
import java.util.List;
import android.os.Bundle;


import android.os.Handler;

//@Events(values={"picture_changed(position As Int), scroll_stopped(), picture_touched(position As Int), picture_long_touched(position As Int)"})
@Events(values={"item_selected(position As Int)"})
@Author("Github: AigeStudio, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("WheelPicker")
//@DependsOn(values={"android-support-v4"})
public class wheelpickerWrapper extends ViewWrapper<WheelPicker> implements DesignerCustomView, WheelPicker.OnItemSelectedListener {


	private BA ba;
	private String eventName;
    private WheelPicker cv;
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new WheelPicker(ba.context);
        this.setObject(cv);

        cv.setOnItemSelectedListener(this);

 	}
	
    @Override
    public void onItemSelected(WheelPicker picker, Object data, int position) {
	    if (ba.subExists(eventName + "_item_selected")) {
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_item_selected", true, new Object[] {position});
	    }
    }	
	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.  
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
    public void setVisibleItemCount(int count) {
        cv.setVisibleItemCount(count);
        cv.invalidate();
    }

    public void setCyclic(boolean isCyclic) {
        cv.setCyclic(isCyclic);
        cv.invalidate();
    }

    public void setSelectedItemPosition(int position) {
        cv.setSelectedItemPosition(position);
        cv.invalidate();
    }

    public void setData(List data) {
        cv.setData(data);
        cv.invalidate();
    }

    public void setSameWidth(boolean hasSameWidth) {
        cv.setSameWidth(hasSameWidth);
        cv.invalidate();
    }

/*     public void setMaximumWidthText(String text) {
        cv.setMaximumWidthText(text);
        cv.invalidate();
    }

    public void setMaximumWidthTextPosition(int position) {
        cv.setMaximumWidthTextPosition(position);
        cv.invalidate();
    } */

    public void setSelectedItemTextColor(int color) {
        cv.setSelectedItemTextColor(color);
        cv.invalidate();
    }

    public void setItemTextColor(int color) {
        cv.setItemTextColor(color);
        cv.invalidate();
    }

    public void setItemTextSize(int size) {
        cv.setItemTextSize(size);
        cv.invalidate();
    }

/*     public void setItemSpace(int space) {
        cv.setItemSpace(space);
        cv.invalidate();
    } */

    public void setIndicator(boolean hasIndicator) {
        cv.setIndicator(hasIndicator);
        cv.invalidate();
    }

/*     public void setIndicatorSize(int size) {
        cv.setIndicatorSize(size);
        cv.invalidate();
    } */

/*     public void setIndicatorColor(int color) {
        cv.setIndicatorColor(color);
        cv.invalidate();
    } */

    public void setCurtain(boolean hasCurtain) {
        cv.setCurtain(hasCurtain);
        cv.invalidate();
    }

    public void setCurtainColor(int color) {
        cv.setCurtainColor(color);
        cv.invalidate();
    }

    public void setAtmospheric(boolean hasAtmospheric) {
        cv.setAtmospheric(hasAtmospheric);
        cv.invalidate();
    }

    public void setCurved(boolean isCurved) {
        cv.setCurved(isCurved);
        cv.invalidate();
    }

    public void setItemAlign(int align) {
        cv.setItemAlign(align);
        cv.invalidate();
    }
 
}
